#include <IRremote.h>
#include <IRremoteInt.h>


/*************************************
 *     *     TIME:20202.04.25
 *     Development Team: MYLS Technology Co.
 *     INFRARED REMOTE CONTROL
 *     מצב שליטה בשלט  אינפרא אדום        
 *     זכור!  יש להתקין קודם את הספריות של אירפרא אדום
 * 
 **************************************/

//------- IR REMOTE CODES ---------//
#define FORWARD 0xFF18E7   //16718055  
#define BACK    0xFF4AB5    //16730805
#define LEFT    0xFF10EF    //16716015
#define RIGHT   0xFF5AA5    //16734885
#define  STOP   0xFF38C7    //16726215   OK KEY
#define Buzzer  0xFFB04F    //16738455   # KEY
 
#define RECV_PIN  2
IRrecv irrecv(RECV_PIN);
decode_results results;
long val;
          //Define the motor pins
int D6= 6;     
int D7 = 7; 
int D8= 8;     
int D9 = 9;
int D10= 10;     
int D12 = 12;
int D13= 13;     
int D11 = 11;   

int speed_f = 0;
int speed_b = 250;
void setup() {
  Serial.begin(9600);  
 irrecv.enableIRIn();
  
  pinMode(D6, OUTPUT);
  pinMode(D7, OUTPUT);
  pinMode(D8, OUTPUT);
  pinMode(D9, OUTPUT);
  pinMode(D10, OUTPUT);
  pinMode(D12, OUTPUT);
  pinMode(D11, OUTPUT);
  pinMode(D13, OUTPUT);
}

  /*************the function to run motor*************/
void Car_front()
{
  analogWrite(D6, speed_f);
  digitalWrite(D7,HIGH);
  
  digitalWrite(D8, HIGH);
  analogWrite(D9,speed_f);
  
  digitalWrite(D12, LOW);
  analogWrite(D10, speed_b);
  
  digitalWrite(D13, LOW);
  analogWrite(D11,HIGH);
}
  
void Car_back()
{
  analogWrite(D6, speed_b);
  digitalWrite(D7,LOW);
    digitalWrite(D8, LOW);
    analogWrite(D9,speed_b);
  digitalWrite(D12, HIGH);
  analogWrite(D10, speed_f);
  digitalWrite(D13, HIGH);
  analogWrite(D11,speed_f);
}
void Car_left()
{
    analogWrite(D6, 0);
    digitalWrite(D7,LOW);
  
    digitalWrite(D8, LOW);
    analogWrite(D9,0);
    
    digitalWrite(D12,LOW);
    analogWrite(D10, 180);
  
    digitalWrite(D13, LOW);
    digitalWrite(D11,HIGH);
}
void Car_right()
{
   analogWrite(D6, 60);
  digitalWrite(D7,HIGH);
    digitalWrite(D8, HIGH);
    analogWrite(D9,60);
  digitalWrite(D12, LOW);
  analogWrite(D10, 0);
  digitalWrite(D13, LOW);
  analogWrite(D11,0);
}
  void Car_Stop()
{
  analogWrite(D6, 0);
  digitalWrite(D7,LOW);
    digitalWrite(D8, LOW);
    analogWrite(D9,0);
  digitalWrite(D12, LOW);
  analogWrite(D10, 0);
  digitalWrite(D13, LOW);
  analogWrite(D11,0);
}
void loop() {
  if (irrecv.decode(&results)){ 
  
    val = results.value;
    Serial.println(val, HEX); 
    irrecv.resume();
  }
   switch(val) {
                case  FORWARD: Car_front(); break;
                case  BACK: Car_back(); break;
                case  LEFT: Car_left(); break;
                case  RIGHT: Car_right(); break;
                case  STOP: Car_Stop(); break;
                default: break;
   }
  
}
